<template>
  <div>
    <div v-if="product">
      <p style="font-weight: bold;">{{ product.title }}</p>
      <p>Цена: {{ product.price }}</p>
      
      <button @click="actualBuy(product)" :disabled="inCart(product)">Купить</button>
      <p>{{ product.description }}</p>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'Catalog',
  props: {
    id: Number
  },
  data() {
    return {
      product: null,
      cart: []
    }
  },
  created() {
    this.fetchProduct()
  },
  methods: {
    ...mapActions('cartModule', ['actualBuy']),
    async fetchProduct() {
      const response = await fetch('http://localhost:3000/products/' + this.id)
      this.product = await response.json()
    },
    inCart() {
      return !!this.$store.state.cartModule.cart.find(p => p.id === this.id)
    }
  }
}
</script>
